/*
 * CAggregationDynamicPointer.cpp
 *
 *  Created on: 02.06.2013
 *      Author: Graf
 */
#include <iostream>     // Header fr die Standard-IO-Objekte (z.B. cout, cin)
#include <stdlib.h>

using namespace std; // Erspart den scope vor Objekte der
                  // C++-Standard-Bibliothek zu schreiben
                  // z.B. statt "std::cout" kann man "cout" schreiben

#include "CPoint.h"
#include "CAggregationDynamicPointer.h"

CAggregationDynamicPointer::CAggregationDynamicPointer( int mxPoints )
{
   m_nPoints = 0;
   m_mxPoints = mxPoints;
   m_ppPoints = new CPoint*[ m_mxPoints ];
}

CAggregationDynamicPointer::~CAggregationDynamicPointer()
{
   cout << "CAggregationDynamicPointer::~CAggregationDynamicPointer()" << endl;
   delete [] m_ppPoints;
}

void CAggregationDynamicPointer::put( CPoint *pPt )
{
   if( m_nPoints >= m_mxPoints )
   {
      m_mxPoints *= 2;  // Speicherplatz verdoppeln
      CPoint **ppPoints = new CPoint*[ m_mxPoints ];

      for( int i = 0; i < m_nPoints; i++ )
      {
         ppPoints[i] = m_ppPoints[i];  // Adresse kopieren
      }

      delete [] m_ppPoints;
      m_ppPoints = ppPoints;
   }

   m_ppPoints[m_nPoints] = pPt;  // Pointer-Zuweisung (Adresse kopieren)
   m_nPoints++;
}

CPoint * CAggregationDynamicPointer::pGet( int i ) const
{
   cout << "CAggregationDynamicPointer::pGet( int i ): ..." << endl;
   return m_ppPoints[i];  // Pointer
}

void CAggregationDynamicPointer::clear()
{
   cout << "CAggregationDynamicPointer::clear(): ..." << endl;
   m_nPoints = 0;
}

void CAggregationDynamicPointer::print() const
{
   cout << "CAggregationDynamicPointer::print(): " << m_nPoints << " of " << m_mxPoints << endl;
}

