/*
 * CKompositionDynamic.cpp
 *
 *  Created on: 02.06.2013
 *      Author: Graf
 */
#include <iostream>     // Header fr die Standard-IO-Objekte (z.B. cout, cin)
#include <stdlib.h>

using namespace std; // Erspart den scope vor Objekte der
                  // C++-Standard-Bibliothek zu schreiben
                  // z.B. statt "std::cout" kann man "cout" schreiben

#include "CPoint.h"
#include "CKompositionDynamic.h"

CKompositionDynamic::CKompositionDynamic( int mxPoints )
{
   m_nPoints = 0;
   m_mxPoints = mxPoints;
   m_pPoints = new CPoint[ m_mxPoints ];
}

CKompositionDynamic::~CKompositionDynamic()
{
   cout << "CKompositionDynamic::~CKompositionDynamic()" << endl;
   delete [] m_pPoints;
}

void CKompositionDynamic::put( const CPoint &rPt )
{
   if( m_nPoints >= m_mxPoints )
   {
      m_mxPoints *= 2;  // Speicherplatz verdoppeln
      CPoint *pPoints = new CPoint[ m_mxPoints ];

      for( int i = 0; i < m_nPoints; i++ )
      {
         pPoints[i] = m_pPoints[i];  // Zuweisungs-Operator
      }

      delete [] m_pPoints;
      m_pPoints = pPoints;
   }

   m_pPoints[m_nPoints] = rPt;  // Zuweisungs-Operator
   m_nPoints++;
}

CPoint CKompositionDynamic::get( int i ) const
{
   cout << "CKompositionDynamic::get( int i ): ..." << endl;
   return m_pPoints[i];  // Kopie
}

void CKompositionDynamic::clear()
{
   cout << "CKompositionDynamic::clear(): ..." << endl;
   m_nPoints = 0;
}

void CKompositionDynamic::print() const
{
   cout << "CKompositionDynamic::print(): " << m_nPoints << " of " << m_mxPoints << endl;
}

