/*
 * CKompositionDynamicPointerPointer.cpp
 *
 *  Created on: 02.06.2013
 *      Author: Graf
 */
#include <iostream>     // Header fr die Standard-IO-Objekte (z.B. cout, cin)
#include <stdlib.h>

using namespace std; // Erspart den scope vor Objekte der
                  // C++-Standard-Bibliothek zu schreiben
                  // z.B. statt "std::cout" kann man "cout" schreiben

#include "CPoint.h"
#include "CKompositionDynamicPointer.h"

CKompositionDynamicPointer::CKompositionDynamicPointer( int mxPoints )
{
   m_nPoints = 0;
   m_mxPoints = mxPoints;
   m_ppPoints = new CPoint*[ m_mxPoints ];
}

CKompositionDynamicPointer::~CKompositionDynamicPointer()
{
   cout << "CKompositionDynamicPointer::~CKompositionDynamicPointer()" << endl;
   for( int i = 0; i < m_nPoints; i++ )
   {
      delete m_ppPoints[i];
   }
   delete [] m_ppPoints;
}

void CKompositionDynamicPointer::put( const CPoint &rPt )
{
   if( m_nPoints >= m_mxPoints )
   {
      m_mxPoints *= 2;  // Speicherplatz verdoppeln
      CPoint **ppPoints = new CPoint*[ m_mxPoints ];

      for( int i = 0; i < m_nPoints; i++ )
      {
         ppPoints[i] = m_ppPoints[i];  // Adresse kopieren
      }

      delete [] m_ppPoints;
      m_ppPoints = ppPoints;
   }

   m_ppPoints[m_nPoints] = new CPoint( rPt );  // Kopie-Konstruktor
   m_nPoints++;
}

CPoint CKompositionDynamicPointer::get( int i ) const
{
   cout << "CKompositionDynamicPointer::get( int i ): ..." << endl;
   return *m_ppPoints[i];  // Kopie
}

void CKompositionDynamicPointer::clear()
{
   cout << "CKompositionDynamicPointer::clear(): ..." << endl;
   for( int i = 0; i < m_nPoints; i++ )
   {
      delete m_ppPoints[i];
   }
   m_nPoints = 0;
}

void CKompositionDynamicPointer::print() const
{
   cout << "CKompositionDynamicPointer::print(): " << m_nPoints << " of " << m_mxPoints << endl;
}

