/*
 * CKompositionStatic.cpp
 *
 *  Created on: 02.06.2013
 *      Author: Graf
 */
#include <iostream>     // Header fr die Standard-IO-Objekte (z.B. cout, cin)
#include <stdlib.h>

using namespace std; // Erspart den scope vor Objekte der
                  // C++-Standard-Bibliothek zu schreiben
                  // z.B. statt "std::cout" kann man "cout" schreiben

#include "CKompositionStatic.h"

CKompositionStatic::CKompositionStatic()
{
   m_nPoints = 0;
   m_mxPoints = sizeof m_aPoints / sizeof m_aPoints[0];
}

CKompositionStatic::~CKompositionStatic()
{
   cout << "CKompositionStatic::~CKompositionStatic()" << endl;
}

void CKompositionStatic::put( const CPoint &rPt )
{
   if( m_nPoints >= m_mxPoints )
   {
      cout << "??? put: already mxPoints = " << m_mxPoints << " Points stored" << endl;
      return;
   }
   m_aPoints[m_nPoints] = rPt;  // Zuweisungs-Operator
   m_nPoints++;
}

CPoint CKompositionStatic::get( int i ) const
{
   cout << "CKompositionStatic::get( int i ): ..." << endl;
   return m_aPoints[i];  // Kopie
}

void CKompositionStatic::clear()
{
   cout << "CKompositionStatic::clear(): ..." << endl;
   m_nPoints = 0;
}

void CKompositionStatic::print() const
{
   cout << "CKompositionStatic::print(): " << m_nPoints << " of " << m_mxPoints << endl;
}


