// GIT-Labor
// main.h

////////////////////////////////////////////////////////////////////////////////
// Header-Dateien
#include <iostream>		// Header fr die Standard-IO-Objekte (z.B. cout, cin)
#include <stdlib.h>

using namespace std;	// Erspart den scope vor Objekte der
						// C++-Standard-Bibliothek zu schreiben
						// z.B. statt "std::cout" kann man "cout" schreiben

// Die generierte Header-Datei wird includiert
#include "CPoint.h"
#include "CKompositionStatic.h"
#include "CKompositionDynamic.h"
#include "CKompositionDynamicPointer.h"
#include "CAggregationDynamicPointer.h"

void testKompositionStatic()
{
   cout << "testKompositionStatic() ..." << endl;
   CKompositionStatic data;

   data.put( CPoint( 1., 2. ) );
   data.put( CPoint( 3., 4. ) );
   data.put( CPoint( 5., 6. ) );
   data.print();

   CPoint pt = data.get(1);
   pt.println();

   data.clear();
   data.print();

   cout << "testKompositionStatic(): \"before\" return" << endl;
}

void testKompositionDynamic()
{
   cout << "testKompositionDynamic() ..." << endl;
   CKompositionDynamic data( 5 );

// CKompositionDynamic o;
// o = data;  // => Compiler-Fehler

   data.put( CPoint( 1., 2. ) );
   data.put( CPoint( 3., 4. ) );
   data.put( CPoint( 5., 6. ) );
   data.print();

   CPoint pt = data.get(1);
   pt.println();

   data.clear();
   data.print();

   cout << "testKompositionDynamic(): \"before\" return" << endl;
}

void testKompositionDynamicPointer()
{
   cout << "testKompositionDynamicPointer() ..." << endl;
   CKompositionDynamicPointer data( 5 );

   data.put( CPoint( 1., 2. ) );
   data.put( CPoint( 3., 4. ) );
   data.put( CPoint( 5., 6. ) );
   data.print();

   CPoint pt = data.get(1);
   pt.println();

   data.clear();
   data.print();

   cout << "testKompositionDynamicPointer(): \"before\" return" << endl;
}

void testAggregationDynamicPointer()
{
   cout << "testAggregationDynamicPointer() ..." << endl;
   CAggregationDynamicPointer data( 5 );

   CPoint pt1 = CPoint( 1., 2. );
   CPoint pt2 = CPoint( 3., 4. );
   CPoint pt3 = CPoint( 5., 6. );

   data.put( &pt1 );
   data.put( &pt2 );
   data.put( &pt3 );
   data.print();

   CPoint *pPt = data.pGet(1);
   pPt->println();

   data.clear();
   data.print();

   cout << "testAggregationDynamicPointer(): \"before\" return" << endl;
}

// Hauptprogramm
// Dient als Testrahmen, von hier aus werden die Klassen aufgerufen
int main (void)
{
   testKompositionStatic();
   cout << "main: after testKompositionStatic()" << endl << endl;

   testKompositionDynamic();
   cout << "main: after testKompositionDynamic()" << endl << endl;

   testKompositionDynamicPointer();
   cout << "main: after testKompositionDynamicPointer()" << endl << endl;

   testAggregationDynamicPointer();
   cout << "main: after testAggregaDynamicPointer()" << endl << endl;

	//	system("pause");
	cout << "main: \"before\" return" << endl;
	return 0;
}
